/*
 *      ,
 *        0x7c00.
 */

/* ,       */
#define BOOT_SEG          0x07c0
/* ,    */
#define INIT_SEG          0x0050
/*    */
#define BOOT_PARTEND      0x01fe
/*     */
#define BOOT_SIGNATURE    0xaa55
/*     */
#define KERNEL_ADDRES     0x0800

/*       */
.code16

.text
.globl _start

/*    */
_start:
	/*
	 *     0x7c00   0x0500.
	 *      .
	 */
	movw $BOOT_SEG, %ax
	movw %ax, %ds
	xorw %si, %si
	movw $INIT_SEG, %ax
	movw %ax, %es
	xorw %di, %di
	movw $256, %cx   /*    512   256  */
	cld
	rep movsw

	/*
	 *    
	 */
	ljmp $INIT_SEG, $next

	/*
	 *       .
	 */
next:
	movw %ax, %ds     /*   */
	movw %ax, %ss     /*   */
	/*
	 *      256  ( ).
	 *     0x0800.
	 */
	movw $(512+256), %sp       /*   +   */

	/*
	 *    0x0800   .
	 *    0x0800   0x0a0000 (638 ).
	 */

	/*     boot. */
	movw $msg, %ax
	pushw %ax
	call puts
	addw $2, %sp
	call print_nl

	/*      0x0800 */
	movw $(KERNEL_ADDRES/0x10), %ax
	movw %ax, %es           /* ,    */
	xorw %bx, %bx           /* ,    */
	movw $0x0002, %cx       /*     */
	movw $0x0000, %dx       /*     */
	movw $0x020f, %ax       /*  2, 10    */
	int $0x13               /*  BIOS */
	/*     */
	jc error_read

	/*       */
	movw $ok_load, %ax
	pushw %ax
	call puts
	addw $2, %sp
	call print_nl

	/*   floppy */
	movw $0x03f2, %dx
	xorb %al, %al
	outb %al, %dx

	/*      */
	jmp start_PM

	/*   */
stop:
	jmp stop

	/*    */
error_read:
	movw $err_load, %ax
	pushw %ax
	call puts
	addw $2, %sp
	call print_nl
	jmp stop

/*
 * void puts(char *str)
 *     .
 */
puts:
	pushw %bp
	movw %sp, %bp
	pushw %si
	pushw %bx

	/*     */
	movw 4(%bp), %si
	/*      */
	movw $0x0007, %bx
	/*  0x0e  0x10 BIOS */
	movb $0x0e, %ah

	/*      */
1:	movb (%si), %al
	testb %al, %al
	jz 2f
	int $0x10
	incw %si
	jmp 1b

2:	popw %bx
	popw %si
	popw %bp
	ret

/*
 * void print_nl(void)
 *    .
 */
print_nl:
	pushw %bx

	/*      */
	movw $0x0007, %bx
	/*
	 *   0x0e  0x10 BIOS,
	 *    .
	 */
	movw $0x0e0a, %ax
	int $0x10
	/*     */
	movb $0x0d, %al
	int $0x10

	popw %bx
	ret

	/*     */
start_PM:
	cli            /*   */
	lgdt _gdtr     /*  GDTR */

	/*    PM */
	movl %cr0, %eax
	orl $1, %eax
	movl %eax, %cr0

	/*
	 *     
	 *  .
	 */
	ljmp $8, $KERNEL_ADDRES

/*  */
msg: .asciz "Boot code starting..."
err_load: .asciz "Loading kernel ERROR..."
ok_load: .asciz "Loading kernel OK..."

.align 2,0
_gdtr:
	.word 23
	.long INIT_SEG*0x10+_gtr

.align 8,0
_gtr:
	.quad 0x0000000000000000
	.quad 0x00c09a00000000bf
	.quad 0x00c09200000000bf

/*    */
. = _start + BOOT_PARTEND
.word BOOT_SIGNATURE
