/*
 * io.h -    -.
 * outb, inb
 */
#ifndef _IO_H_
#define _IO_H_

/*  */
#define __JUMPING()  __asm__ __volatile__ ("jmp 1f\n1:\tjmp 1f\n1:")

/*    */
extern inline unsigned char inb(unsigned short port)
{
	unsigned char __v;
	__asm__ __volatile__ ("inb %w1, %0" : "=a" (__v) : "Nd" (port));
	return __v;
}

extern inline unsigned int inb_p(unsigned short port)
{
	unsigned char __v;
	__asm__ __volatile__ ("inb %w1, %0" : "=a" (__v) : "Nd" (port));
	__JUMPING();
	return __v;
}

extern inline unsigned short inw(unsigned short port)
{
	unsigned short __v;
	__asm__ __volatile__ ("inw %w1, %0" : "=a" (__v) : "Nd" (port));
	return __v;
}

extern inline unsigned short inw_p(unsigned short port)
{
	unsigned short __v;
	__asm__ __volatile__ ("inw %w1, %0" : "=a" (__v) : "Nd" (port));
	__JUMPING();
	return __v;
}

extern inline unsigned int inl(unsigned short port)
{
	unsigned int __v;
	__asm__ __volatile__ ("inl %w1, %0" : "=a" (__v) : "Nd" (port));
	return __v;
}

extern inline unsigned int inl_p(unsigned short port)
{
	unsigned int __v;
	__asm__ __volatile__ ("inl %w1, %0" : "=a" (__v) : "Nd" (port));
	__JUMPING();
	return __v;
}

/*    */
extern inline void outb(unsigned char value, unsigned short port)
{
	__asm__ __volatile__ ("outb %b0, %w1" : : "a" (value), "Nd" (port));
}

extern inline void outb_p(unsigned char value, unsigned short port)
{
	__asm__ __volatile__ ("outb %b0, %w1" : : "a" (value), "Nd" (port));
	__JUMPING();
}

extern inline void outw(unsigned short value, unsigned short port)
{
	__asm__ __volatile__ ("outw %w0, %w1" : : "a" (value), "Nd" (port));
}

extern inline void outw_p(unsigned short value, unsigned short port)
{
	__asm__ __volatile__ ("outw %w0, %w1" : : "a" (value), "Nd" (port));
	__JUMPING();
}

extern inline void outl(unsigned int value, unsigned short port)
{
	__asm__ __volatile__ ("outl %0, %w1" : : "a" (value), "Nd" (port));
}

extern inline void outl_p(unsigned int value, unsigned short port)
{
	__asm__ __volatile__ ("outl %0, %w1" : : "a" (value), "Nd" (port));
	__JUMPING();
}

#endif  /* _IO_H_ */
