/*
 * system.h
 */
#ifndef _SYSTEM_H_
#define _SYSTEM_H_

/*   */
#define nop() __asm__ __volatile__ ("nop" ::)
/*   */
#define cli() __asm__ __volatile__ ("cli" ::: "memory")
/*   */
#define sti() __asm__ __volatile__ ("sti" ::: "memory")
/*  hlt */
#define hlt() __asm__ __volatile__ ("hlt" ::: "memory")

/*    */
extern inline unsigned int get_flags(void)
{
	unsigned int __v;
	__asm__ __volatile__ ("pushfl; popl %0" : "=r" (__v) : );
	return __v;
}

/*     */
extern inline void set_flags(unsigned int value)
{
	__asm__ __volatile__ ("pushl %0; popfl" : : "g" (value) : "memory", "cc");
}

#endif  /* _SYSTEM_H_ */
