/*
 * asm.S
 */

.code32

.text
traps:
	xchgl %eax, (%esp)
	pushl %ebx
	pushl %ecx
	pushl %edx
	pushl %ebp
	pushl %esp
	pushl %esi
	pushl %edi
	pushl %ds
	pushl %es
	pushl %fs
	pushl %gs

	movl $16, %ebx
	movw %bx, %ds
	movw %bx, %es
	movw %bx, %fs
	movw %bx, %gs

	lea 48(%esp), %ebx
	lea (%esp), %ecx

	pushl %ebx
	pushl %ecx
	call *%eax
	addl $8, %esp

	popl %gs
	popl %fs
	popl %es
	popl %ds
	popl %edi
	popl %esi
	popl %esp
	popl %ebp
	popl %edx
	popl %ecx
	popl %ebx
	popl %eax
	addl $4, %esp
	iret

.globl divide_error
divide_error:
	pushl $0      /* error code */
	pushl $do_divide_error
	jmp traps

.globl debug
debug:
	pushl $0      /* error code */
	pushl $do_debug
	jmp traps

.globl nmi
nmi:
	pushl $0
	pushl $do_nmi
	jmp traps

.globl int3
int3:
	pushl $0
	pushl $do_int3
	jmp traps

.globl overflow
overflow:
	pushl $0
	pushl $do_overflow
	jmp traps

.globl bound
bound:
	pushl $0
	pushl $do_bound
	jmp traps

.globl invalid_op
invalid_op:
	pushl $0
	pushl $do_invalid_op
	jmp traps

.globl not_device
not_device:
	pushl $0
	pushl $do_not_device
	jmp traps

.globl double_fault
double_fault:
	pushl $do_double_fault
	jmp traps

.globl coprocessor_segment_ove
coprocessor_segment_ove:
	pushl $0
	pushl $do_coprocessor_segment_ove
	jmp traps

.globl invalid_TSS
invalid_TSS:
	pushl $do_invalid_TSS
	jmp traps

.globl segment_not_present
segment_not_present:
	pushl $do_segment_not_present
	jmp traps

.globl segment_stack_error
segment_stack_error:
	pushl $do_segment_stack_error
	jmp traps

.globl general_protection
general_protection:
	pushl $do_general_protection
	jmp traps

.globl page_fault
page_fault:
	pushl $do_page_fault
	jmp traps

.globl coprocessor_error
coprocessor_error:
	pushl $0
	pushl $do_coprocessor_error
	jmp traps

.globl trap_reserved
trap_reserved:
	pushl $0
	pushl $do_trap_reserved
	jmp traps
