#include <syscall.h>
#include <traps.h>
#include <display.h>
#include <kernel.h>

extern void sys_call(void);

int do_sys_call(int i, int b)
{
	int ret;

	if( i == 1 )
	{
		puts("Syscall enter OK\n");
		ret = 0;
	}
	else if( i == 2 )
		ret = putchar(b);
	else
	{
		puts("Syscall enter ERROR\n");
		ret = -1;
	}

	return ret;
}

int syscall(int i, int b)
{
	int prm;
	__asm__ __volatile__ (
			"movl %1, %0 \n"
			"movl %2, %%ecx \n"
			"int $48 \n"
			: "=a" (prm)
			: "g" (i), "g" (b));
	return prm;
}

void syscall_init(void)
{
	idt[48].a = (8 << 16) | ((unsigned int)sys_call & 0xffff);
	idt[48].b = ((unsigned int)sys_call & 0xffff0000) | 0xef00;
//	set_trap(48,sys_call);
	puts("Syscall init OK...\n");
}
