/*
 * system.S
 */

.code32

.text
.globl irq_reserved
irq_reserved:
	pushl %eax
	pushl %ecx
	pushl %edx
	pushl %ds
	pushl %es
	pushl %fs
	pushl %gs

	movl $16, %eax
	movw %ax, %ds
	movw %ax, %es
	movw %ax, %fs
	movw %ax, %gs

	call do_irq_reserved

	popl %gs
	popl %fs
	popl %es
	popl %ds
	popl %edx
	popl %ecx
	popl %eax
	iret

.globl irq_keyboard
irq_keyboard:
	pushl %eax
	pushl %ecx
	pushl %edx
	pushl %ds
	movw $16, %ax
	movw %ax, %ds

	call do_keyboard

	popl %ds
	popl %edx
	popl %ecx
	popl %eax
	iret

.globl irq_timer
irq_timer:
	pushl %eax
	pushl %ecx
	pushl %edx
	pushl %ds
	movw $16, %ax
	movw %ax, %ds


	leal 16(%esp), %eax
	pushl %eax
	call do_timer
	popl %eax

	popl %ds
	popl %edx
	popl %ecx
	popl %eax
	iret

.globl sys_call
sys_call:
	pushl %ds
	pushl %ecx
	pushl %eax    /*     */
	movw $16, %ax
	movw %ax, %ds

	call do_sys_call
	addl $8, %esp

	popl %ds
	iret
